def fromPt(p, q, A, B, r):
    #print()
    #print(p, q, A, B, r)
    ba = B / A
    qa = ba * ba + 1
    qb = -(2 * p + 2 * ba * q)
    qc = p*p + q * q - r*r

    discr = qb * qb - 4 * qa * qc

    if discr < 0:
        return None
    else:
        a = -qb / (2 * qa)
        b = 1 / (2 * qa)
        s = discr
        x0 = a - b * s ** (1/2) - 0.000001
        x1 = a + b * s ** (1/2) + 0.000001
        return x0, x1
 


n, r, a, b = list(map(int, input().split(' ')))

edges = []

swapCoords = False

if a == 0:
    swapCoords = True
    a = b
    b = 0

for i in range(n):
    x, y = list(map(int, input().split(' ')))
    if swapCoords:
        x, y = y, x
    res = fromPt(x, y, a, b, r)
    #print(res)
    if res is not None:
        ll, rr = res
        edges.append((ll, True))
        edges.append((rr, False))

maxcnt = 0 
curcnt = 0

edges.sort()

for _, start in edges:
    if start:
        curcnt += 1
        maxcnt = max(curcnt, maxcnt)
    else:
        curcnt -= 1

print(maxcnt)
